Index: /trunk/sources/HeuristicLab.Settings/MainForm.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Settings/MainForm.Designer.cs	(revision 774)
+++ /trunk/sources/HeuristicLab.Settings/MainForm.Designer.cs	(revision 775)
@@ -27,11 +27,16 @@
       this.button1 = new System.Windows.Forms.Button();
       this.textBox2 = new System.Windows.Forms.TextBox();
+      this.button2 = new System.Windows.Forms.Button();
+      this.label1 = new System.Windows.Forms.Label();
+      this.label2 = new System.Windows.Forms.Label();
       this.SuspendLayout();
       // 
       // textBox1
       // 
-      this.textBox1.Location = new System.Drawing.Point(12, 12);
+      this.textBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.textBox1.Location = new System.Drawing.Point(80, 12);
       this.textBox1.Name = "textBox1";
-      this.textBox1.Size = new System.Drawing.Size(260, 20);
+      this.textBox1.Size = new System.Drawing.Size(192, 20);
       this.textBox1.TabIndex = 0;
       this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
@@ -39,9 +44,10 @@
       // button1
       // 
-      this.button1.Location = new System.Drawing.Point(12, 38);
+      this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.button1.Location = new System.Drawing.Point(116, 78);
       this.button1.Name = "button1";
       this.button1.Size = new System.Drawing.Size(75, 23);
       this.button1.TabIndex = 1;
-      this.button1.Text = "button1";
+      this.button1.Text = "Save";
       this.button1.UseVisualStyleBackColor = true;
       this.button1.Click += new System.EventHandler(this.button1_Click);
@@ -49,10 +55,40 @@
       // textBox2
       // 
-      this.textBox2.Location = new System.Drawing.Point(12, 106);
+      this.textBox2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.textBox2.Location = new System.Drawing.Point(80, 38);
       this.textBox2.Name = "textBox2";
-      this.textBox2.ReadOnly = true;
-      this.textBox2.Size = new System.Drawing.Size(260, 20);
+      this.textBox2.Size = new System.Drawing.Size(192, 20);
       this.textBox2.TabIndex = 0;
-      this.textBox2.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
+      this.textBox2.TextChanged += new System.EventHandler(this.textBox2_TextChanged);
+      // 
+      // button2
+      // 
+      this.button2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.button2.Location = new System.Drawing.Point(197, 78);
+      this.button2.Name = "button2";
+      this.button2.Size = new System.Drawing.Size(75, 23);
+      this.button2.TabIndex = 2;
+      this.button2.Text = "Reload";
+      this.button2.UseVisualStyleBackColor = true;
+      this.button2.Click += new System.EventHandler(this.button2_Click);
+      // 
+      // label1
+      // 
+      this.label1.AutoSize = true;
+      this.label1.Location = new System.Drawing.Point(12, 15);
+      this.label1.Name = "label1";
+      this.label1.Size = new System.Drawing.Size(62, 13);
+      this.label1.TabIndex = 3;
+      this.label1.Text = "Application:";
+      // 
+      // label2
+      // 
+      this.label2.AutoSize = true;
+      this.label2.Location = new System.Drawing.Point(12, 41);
+      this.label2.Name = "label2";
+      this.label2.Size = new System.Drawing.Size(32, 13);
+      this.label2.TabIndex = 3;
+      this.label2.Text = "User:";
       // 
       // MainForm
@@ -60,5 +96,8 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.ClientSize = new System.Drawing.Size(284, 264);
+      this.ClientSize = new System.Drawing.Size(284, 113);
+      this.Controls.Add(this.label2);
+      this.Controls.Add(this.label1);
+      this.Controls.Add(this.button2);
       this.Controls.Add(this.button1);
       this.Controls.Add(this.textBox2);
@@ -77,4 +116,7 @@
     private System.Windows.Forms.Button button1;
     private System.Windows.Forms.TextBox textBox2;
+    private System.Windows.Forms.Button button2;
+    private System.Windows.Forms.Label label1;
+    private System.Windows.Forms.Label label2;
   }
 }
Index: /trunk/sources/HeuristicLab.Settings/MainForm.cs
===================================================================
--- /trunk/sources/HeuristicLab.Settings/MainForm.cs	(revision 774)
+++ /trunk/sources/HeuristicLab.Settings/MainForm.cs	(revision 775)
@@ -17,7 +17,6 @@
     private void MainForm_Load(object sender, EventArgs e) {
       settings = Properties.Settings.Default;
-      settings.Reload();
-      textBox1.Text = settings.AnotherSetting;
-      textBox2.Text = settings.MySetting;
+      textBox1.Text = settings.MyApplicationSetting;
+      textBox2.Text = settings.MyUserSetting;
     }
 
@@ -27,5 +26,15 @@
 
     private void textBox1_TextChanged(object sender, EventArgs e) {
-      settings.AnotherSetting = textBox1.Text;
+      settings.MyApplicationSetting = textBox1.Text;
+    }
+
+    private void textBox2_TextChanged(object sender, EventArgs e) {
+      settings.MyUserSetting = textBox2.Text;
+    }
+
+    private void button2_Click(object sender, EventArgs e) {
+      settings.Reload();
+      textBox1.Text = settings.MyApplicationSetting;
+      textBox2.Text = settings.MyUserSetting;
     }
   }
Index: /trunk/sources/HeuristicLab.Settings/Properties/Settings.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Settings/Properties/Settings.Designer.cs	(revision 774)
+++ /trunk/sources/HeuristicLab.Settings/Properties/Settings.Designer.cs	(revision 775)
@@ -26,8 +26,11 @@
         [global::System.Configuration.ApplicationScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("Nice Value")]
-        public string MySetting {
+        [global::System.Configuration.DefaultSettingValueAttribute("Application Setting Value")]
+        public string MyApplicationSetting {
             get {
-                return ((string)(this["MySetting"]));
+                return ((string)(this["MyApplicationSetting"]));
+            }
+            set {
+                this["MyApplicationSetting"] = value;
             }
         }
@@ -35,11 +38,11 @@
         [global::System.Configuration.UserScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("COOL!!")]
-        public string AnotherSetting {
+        [global::System.Configuration.DefaultSettingValueAttribute("User Setting Value")]
+        public string MyUserSetting {
             get {
-                return ((string)(this["AnotherSetting"]));
+                return ((string)(this["MyUserSetting"]));
             }
             set {
-                this["AnotherSetting"] = value;
+                this["MyUserSetting"] = value;
             }
         }
Index: /trunk/sources/HeuristicLab.Settings/Properties/Settings.settings
===================================================================
--- /trunk/sources/HeuristicLab.Settings/Properties/Settings.settings	(revision 774)
+++ /trunk/sources/HeuristicLab.Settings/Properties/Settings.settings	(revision 775)
@@ -3,9 +3,9 @@
   <Profiles />
   <Settings>
-    <Setting Name="MySetting" Type="System.String" Scope="Application">
-      <Value Profile="(Default)">Nice Value</Value>
+    <Setting Name="MyApplicationSetting" Type="System.String" Scope="Application">
+      <Value Profile="(Default)">Application Setting Value</Value>
     </Setting>
-    <Setting Name="AnotherSetting" Type="System.String" Scope="User">
-      <Value Profile="(Default)">COOL!!</Value>
+    <Setting Name="MyUserSetting" Type="System.String" Scope="User">
+      <Value Profile="(Default)">User Setting Value</Value>
     </Setting>
   </Settings>
Index: /trunk/sources/HeuristicLab.Settings/app.config
===================================================================
--- /trunk/sources/HeuristicLab.Settings/app.config	(revision 774)
+++ /trunk/sources/HeuristicLab.Settings/app.config	(revision 775)
@@ -11,6 +11,6 @@
     <applicationSettings>
         <HeuristicLab.Settings.Properties.Settings>
-            <setting name="MySetting" serializeAs="String">
-                <value>Nice Value</value>
+            <setting name="MyApplicationSetting" serializeAs="String">
+                <value>Application Setting Value</value>
             </setting>
         </HeuristicLab.Settings.Properties.Settings>
@@ -18,6 +18,6 @@
     <userSettings>
         <HeuristicLab.Settings.Properties.Settings>
-            <setting name="AnotherSetting" serializeAs="String">
-                <value>COOL!!</value>
+            <setting name="MyUserSetting" serializeAs="String">
+                <value>User Setting Value</value>
             </setting>
         </HeuristicLab.Settings.Properties.Settings>