Index: trunk/sources/HeuristicLab.Hive.Client.Common/Logging.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Common/Logging.cs	(revision 781)
+++ trunk/sources/HeuristicLab.Hive.Client.Common/Logging.cs	(revision 782)
@@ -40,5 +40,5 @@
     /// </summary>
     /// <returns>the instance of the logger</returns>
-    public static Logging getInstance() {
+    public static Logging GetInstance() {
       if (instance == null)
         instance = new Logging();
Index: trunk/sources/HeuristicLab.Hive.Client.Common/Properties/AssemblyInfo.frame
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Common/Properties/AssemblyInfo.frame	(revision 781)
+++ trunk/sources/HeuristicLab.Hive.Client.Common/Properties/AssemblyInfo.frame	(revision 782)
@@ -24,4 +24,5 @@
 using System.Runtime.InteropServices;
 using HeuristicLab.PluginInfrastructure;
+using System.Security;
 
 // General Information about an assembly is controlled through the following 
@@ -36,4 +37,5 @@
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
+[assembly: AllowPartiallyTrustedCallers]
 
 // Setting ComVisible to false makes the types in this assembly not visible 
Index: trunk/sources/HeuristicLab.Hive.Client.Common/TestJob.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Common/TestJob.cs	(revision 781)
+++ trunk/sources/HeuristicLab.Hive.Client.Common/TestJob.cs	(revision 782)
@@ -33,9 +33,9 @@
         for (int y = 0; y < Int32.MaxValue; y++) ;
         if (abort == true) {
-          Logging.getInstance().Info(this.ToString(), "Job Processing aborted");
+          Logging.GetInstance().Info(this.ToString(), "Job Processing aborted");
           Debug.WriteLine("Job Abort Processing");
           break;
         }
-        Logging.getInstance().Info(this.ToString(), "Iteration " + x + " done");
+        Logging.GetInstance().Info(this.ToString(), "Iteration " + x + " done");
         Debug.WriteLine("Iteration " + x + " done");
       }      
Index: trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs	(revision 781)
+++ trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs	(revision 782)
@@ -61,5 +61,5 @@
       Heartbeat beat = new Heartbeat();
       beat.Interval = 5000;
-      beat.StartHeartbeat();
+      beat.StartHeartbeat();  
 
       MessageQueue queue = MessageQueue.GetInstance();
@@ -68,5 +68,5 @@
         MessageContainer container = queue.GetMessage();
         Debug.WriteLine("Main loop received this message: " + container.Message.ToString());
-        Logging.getInstance().Info(this.ToString(), container.Message.ToString()); 
+        Logging.GetInstance().Info(this.ToString(), container.Message.ToString()); 
         DetermineAction(container);
       }
@@ -77,5 +77,5 @@
       if (sandboxed) {
         pset = new PermissionSet(PermissionState.None);
-        pset.AddPermission(new SecurityPermission(SecurityPermissionFlag.Execution));
+        pset.AddPermission(new SecurityPermission(SecurityPermissionFlag.Execution));        
       } else {
         pset = new PermissionSet(PermissionState.Unrestricted);
@@ -108,7 +108,9 @@
         
         case MessageContainer.MessageType.FetchJob:
+          bool sandboxed = true;
+
           IJob job = CreateNewJob();
           
-          AppDomain appDomain = CreateNewAppDomain(false);
+          AppDomain appDomain = CreateNewAppDomain(true);
           appDomains.Add(job.JobId, appDomain);
           
Index: trunk/sources/HeuristicLab.Hive.Client.ExecutionEngine/Properties/AssemblyInfo.frame
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.ExecutionEngine/Properties/AssemblyInfo.frame	(revision 781)
+++ trunk/sources/HeuristicLab.Hive.Client.ExecutionEngine/Properties/AssemblyInfo.frame	(revision 782)
@@ -24,4 +24,5 @@
 using System.Runtime.InteropServices;
 using HeuristicLab.PluginInfrastructure;
+using System.Security;
 
 // General Information about an assembly is controlled through the following 
@@ -36,4 +37,5 @@
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
+[assembly: AllowPartiallyTrustedCallers]
 
 // Setting ComVisible to false makes the types in this assembly not visible 