Index: trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerConsole.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerConsole.cs	(revision 778)
+++ trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerConsole.cs	(revision 785)
@@ -34,4 +34,5 @@
   public partial class HiveServerConsole : Form {
 
+    HiveServerConsoleInformation information = null;
 
     public HiveServerConsole() {
@@ -47,7 +48,7 @@
       if (ipIsValid()) {
         this.Visible = false;
-        // Form information = new HiveServerConsoleInformation();
-        // Application.Run(information);
-        this.Visible = true;
+        information = new HiveServerConsoleInformation();
+        information.closeFormEvent += new closeForm(enableForm);
+        information.Show();
       }
     }
@@ -56,4 +57,10 @@
       return true;
     }
+
+    private void enableForm(bool cf) {
+      if (cf) {
+        this.Visible = true;
+      }
+    }
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerConsoleInformation.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerConsoleInformation.Designer.cs	(revision 778)
+++ trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerConsoleInformation.Designer.cs	(revision 785)
@@ -24,5 +24,34 @@
     /// </summary>
     private void InitializeComponent() {
+      this.menuStrip1 = new System.Windows.Forms.MenuStrip();
+      this.informationToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.closeToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.menuStrip1.SuspendLayout();
       this.SuspendLayout();
+      // 
+      // menuStrip1
+      // 
+      this.menuStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
+            this.informationToolStripMenuItem});
+      this.menuStrip1.Location = new System.Drawing.Point(0, 0);
+      this.menuStrip1.Name = "menuStrip1";
+      this.menuStrip1.Size = new System.Drawing.Size(651, 24);
+      this.menuStrip1.TabIndex = 0;
+      this.menuStrip1.Text = "menuStrip1";
+      // 
+      // informationToolStripMenuItem
+      // 
+      this.informationToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
+            this.closeToolStripMenuItem});
+      this.informationToolStripMenuItem.Name = "informationToolStripMenuItem";
+      this.informationToolStripMenuItem.Size = new System.Drawing.Size(75, 20);
+      this.informationToolStripMenuItem.Text = "Information";
+      // 
+      // closeToolStripMenuItem
+      // 
+      this.closeToolStripMenuItem.Name = "closeToolStripMenuItem";
+      this.closeToolStripMenuItem.Size = new System.Drawing.Size(152, 22);
+      this.closeToolStripMenuItem.Text = "Close";
+      this.closeToolStripMenuItem.Click += new System.EventHandler(this.close_Click);
       // 
       // HiveServerConsoleInformation
@@ -31,11 +60,21 @@
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.ClientSize = new System.Drawing.Size(651, 402);
+      this.Controls.Add(this.menuStrip1);
+      this.MainMenuStrip = this.menuStrip1;
       this.Name = "HiveServerConsoleInformation";
       this.Text = "HiveServerConsoleInformation";
+      this.Click += new System.EventHandler(this.close_Click);
+      this.menuStrip1.ResumeLayout(false);
+      this.menuStrip1.PerformLayout();
       this.ResumeLayout(false);
+      this.PerformLayout();
 
     }
 
     #endregion
+
+    private System.Windows.Forms.MenuStrip menuStrip1;
+    private System.Windows.Forms.ToolStripMenuItem informationToolStripMenuItem;
+    private System.Windows.Forms.ToolStripMenuItem closeToolStripMenuItem;
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerConsoleInformation.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerConsoleInformation.cs	(revision 778)
+++ trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerConsoleInformation.cs	(revision 785)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Collections.Generic;
 using System.ComponentModel;
@@ -9,8 +30,21 @@
 
 namespace HeuristicLab.Hive.Server.Console {
+
+  public delegate void closeForm(bool cf);
+
   public partial class HiveServerConsoleInformation : Form {
+
+    public event closeForm closeFormEvent;
+
     public HiveServerConsoleInformation() {
       InitializeComponent();
     }
+
+    private void close_Click(object sender, EventArgs e) {
+      if (closeFormEvent != null) {
+        closeFormEvent(true);
+      }
+      this.Close();
+    }
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerConsoleInformation.resx
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerConsoleInformation.resx	(revision 778)
+++ trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerConsoleInformation.resx	(revision 785)
@@ -118,3 +118,6 @@
     <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
   </resheader>
+  <metadata name="menuStrip1.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>17, 17</value>
+  </metadata>
 </root>