Index: /trunk/sources/HeuristicLab.Hive.Client.Communication/ServerProxy.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Communication/ServerProxy.cs	(revision 790)
+++ /trunk/sources/HeuristicLab.Hive.Client.Communication/ServerProxy.cs	(revision 791)
@@ -10,8 +10,8 @@
 
     [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IClientCommunicator/Login", ReplyAction = "http://tempuri.org/IClientCommunicator/LoginResponse")]
-    HeuristicLab.Hive.Contracts.Response Login(HeuristicLab.Hive.Contracts.BusinessObjects.Client clientInfo);
+    HeuristicLab.Hive.Contracts.Response Login(HeuristicLab.Hive.Contracts.BusinessObjects.ClientInfo clientInfo);
 
     [System.ServiceModel.OperationContractAttribute(AsyncPattern = true, Action = "http://tempuri.org/IClientCommunicator/Login", ReplyAction = "http://tempuri.org/IClientCommunicator/LoginResponse")]
-    System.IAsyncResult BeginLogin(HeuristicLab.Hive.Contracts.BusinessObjects.Client clientInfo, System.AsyncCallback callback, object asyncState);
+    System.IAsyncResult BeginLogin(HeuristicLab.Hive.Contracts.BusinessObjects.ClientInfo clientInfo, System.AsyncCallback callback, object asyncState);
 
     HeuristicLab.Hive.Contracts.Response EndLogin(System.IAsyncResult result);
@@ -212,10 +212,10 @@
     public event System.EventHandler<LogoutCompletedEventArgs> LogoutCompleted;
 
-    public HeuristicLab.Hive.Contracts.Response Login(HeuristicLab.Hive.Contracts.BusinessObjects.Client clientInfo) {
+    public HeuristicLab.Hive.Contracts.Response Login(HeuristicLab.Hive.Contracts.BusinessObjects.ClientInfo clientInfo) {
       return base.Channel.Login(clientInfo);
     }
 
     [System.ComponentModel.EditorBrowsableAttribute(System.ComponentModel.EditorBrowsableState.Advanced)]
-    public System.IAsyncResult BeginLogin(HeuristicLab.Hive.Contracts.BusinessObjects.Client clientInfo, System.AsyncCallback callback, object asyncState) {
+    public System.IAsyncResult BeginLogin(HeuristicLab.Hive.Contracts.BusinessObjects.ClientInfo clientInfo, System.AsyncCallback callback, object asyncState) {
       return base.Channel.BeginLogin(clientInfo, callback, asyncState);
     }
@@ -227,5 +227,5 @@
 
     private System.IAsyncResult OnBeginLogin(object[] inValues, System.AsyncCallback callback, object asyncState) {
-      HeuristicLab.Hive.Contracts.BusinessObjects.Client clientInfo = ((HeuristicLab.Hive.Contracts.BusinessObjects.Client)(inValues[0]));
+      HeuristicLab.Hive.Contracts.BusinessObjects.ClientInfo clientInfo = ((HeuristicLab.Hive.Contracts.BusinessObjects.ClientInfo)(inValues[0]));
       return this.BeginLogin(clientInfo, callback, asyncState);
     }
@@ -244,9 +244,9 @@
     }
 
-    public void LoginAsync(HeuristicLab.Hive.Contracts.BusinessObjects.Client clientInfo) {
+    public void LoginAsync(HeuristicLab.Hive.Contracts.BusinessObjects.ClientInfo clientInfo) {
       this.LoginAsync(clientInfo, null);
     }
 
-    public void LoginAsync(HeuristicLab.Hive.Contracts.BusinessObjects.Client clientInfo, object userState) {
+    public void LoginAsync(HeuristicLab.Hive.Contracts.BusinessObjects.ClientInfo clientInfo, object userState) {
       if ((this.onBeginLoginDelegate == null)) {
         this.onBeginLoginDelegate = new BeginOperationDelegate(this.OnBeginLogin);
Index: /trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs	(revision 790)
+++ /trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs	(revision 791)
@@ -64,5 +64,5 @@
       beat.StartHeartbeat();
 
-      BO.Client clientInfo = new BO.Client { ClientId = Guid.NewGuid() };
+      BO.ClientInfo clientInfo = new BO.ClientInfo { ClientId = Guid.NewGuid() };
 
       ClientCommunicatorClient clientCommunicator = ServiceLocator.GetClientCommunicator();
Index: /trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Client.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Client.cs	(revision 790)
+++ /trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Client.cs	(revision 791)
@@ -31,5 +31,5 @@
 
   [DataContract]
-  public class Client : Resource {
+  public class ClientInfo : Resource {
     [DataMember]
     public Guid ClientId { get; set; }
Index: /trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Job.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Job.cs	(revision 790)
+++ /trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Job.cs	(revision 791)
@@ -35,5 +35,5 @@
     public State State { get; set; }
     [DataMember]
-    public Client Client { get; set; }
+    public ClientInfo Client { get; set; }
     [DataMember]
     public Job parentJob { get; set; }
Index: /trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/JobResult.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/JobResult.cs	(revision 790)
+++ /trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/JobResult.cs	(revision 791)
@@ -35,5 +35,5 @@
     public String Result { get; set; } // TODO DataStructure for Result needs to be defined
     [DataMember]
-    public Client Client { get; set; }
+    public ClientInfo Client { get; set; }
 
   }
Index: /trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/UpTimeStatistics.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/UpTimeStatistics.cs	(revision 790)
+++ /trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/UpTimeStatistics.cs	(revision 791)
@@ -31,5 +31,5 @@
   public class UpTimeStatistics {
     [DataMember]
-    public Client Client { get; set; }
+    public ClientInfo Client { get; set; }
     [DataMember]
     public DateTime Login { get; set; }
Index: /trunk/sources/HeuristicLab.Hive.Contracts/Interfaces/IClientCommunicator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Contracts/Interfaces/IClientCommunicator.cs	(revision 790)
+++ /trunk/sources/HeuristicLab.Hive.Contracts/Interfaces/IClientCommunicator.cs	(revision 791)
@@ -34,5 +34,5 @@
   public interface IClientCommunicator {
     [OperationContract]
-    Response Login(Client clientInfo);
+    Response Login(ClientInfo clientInfo);
     [OperationContract]
     ResponseHB SendHeartBeat(HeartBeatData hbData);
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/ClientCommunicator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/ClientCommunicator.cs	(revision 790)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/ClientCommunicator.cs	(revision 791)
@@ -12,5 +12,5 @@
   /// </summary>
   public class ClientCommunicator: IClientCommunicator {
-    List<Client> clients;
+    List<ClientInfo> clients;
     List<long> jobs;
     int nrOfJobs = 10;
@@ -25,7 +25,7 @@
     #region IClientCommunicator Members
 
-    public Response Login(Client clientInfo) {
+    public Response Login(ClientInfo clientInfo) {
       if (clients == null)
-        clients = new List<Client>();
+        clients = new List<ClientInfo>();
 
       clients.Add(clientInfo);
@@ -72,5 +72,5 @@
     public Response Logout(Guid clientId) {
       bool clientRemoved = false;
-      foreach (Client client in clients) {
+      foreach (ClientInfo client in clients) {
         if (client.ClientId.Equals(clientId)) {
           clients.Remove(client);