Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Client.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Client.cs	(revision 794)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Client.cs	(revision 795)
@@ -33,7 +33,11 @@
   public class ClientInfo : Resource {
     [DataMember]
+    public long ClientInfoId { get; set; }
+    [DataMember]
     public Guid ClientId { get; set; }
     [DataMember]
     public int NrOfCores { get; set; }
+    [DataMember]
+    public int CpuSpeedPerCore { get; set; }
     [DataMember]
     public int Memory { get; set; }
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/ClientConfig.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/ClientConfig.cs	(revision 794)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/ClientConfig.cs	(revision 795)
@@ -31,4 +31,6 @@
   public class ClientConfig {
     [DataMember]
+    public long ClientConfigId { get; set; }
+    [DataMember]
     public String UpDownTimeCalendar { get; set; } // TODO define DataStructure
     [DataMember]
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/ClientGroup.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/ClientGroup.cs	(revision 794)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/ClientGroup.cs	(revision 795)
@@ -31,4 +31,6 @@
   public class ClientGroup : Resource {
     [DataMember]
+    public long ClientGroupId { get; set; }
+    [DataMember]
     public String Name { get; set; }
   }
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/GrantedPermissions.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/GrantedPermissions.cs	(revision 794)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/GrantedPermissions.cs	(revision 795)
@@ -31,4 +31,6 @@
   public class GrantedPermissions {
     [DataMember]
+    public long GrantedPermissionsId { get; set; }
+    [DataMember]
     public Permission Permission { get; set; }
     [DataMember]
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/JobResult.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/JobResult.cs	(revision 794)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/JobResult.cs	(revision 795)
@@ -31,4 +31,6 @@
   public class JobResult {
     [DataMember]
+    public long JobResultId { get; set; }
+    [DataMember]
     public Job Job { get; set; }
     [DataMember]
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Permission.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Permission.cs	(revision 794)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Permission.cs	(revision 795)
@@ -31,4 +31,6 @@
   public class Permission {
     [DataMember]
+    public long PermissionId { get; set; }
+    [DataMember]
     public String Name { get; set; }
   }
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/PermissionOwner.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/PermissionOwner.cs	(revision 794)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/PermissionOwner.cs	(revision 795)
@@ -30,5 +30,7 @@
   [DataContract]
   public class PermissionOwner {
-
+    [DataMember]
+    public long PermissionOwnerId { get; set; }
+    
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Resource.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Resource.cs	(revision 794)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/Resource.cs	(revision 795)
@@ -30,4 +30,6 @@
   [DataContract]
   public class Resource {
+    [DataMember]
+    public long ResourceId { get; set; }
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/UpTimeStatistics.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/UpTimeStatistics.cs	(revision 794)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/UpTimeStatistics.cs	(revision 795)
@@ -31,4 +31,6 @@
   public class UpTimeStatistics {
     [DataMember]
+    public long UpTimeStatisticsId { get; set; }
+    [DataMember]
     public ClientInfo Client { get; set; }
     [DataMember]
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/User.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/User.cs	(revision 794)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/User.cs	(revision 795)
@@ -31,4 +31,6 @@
   public class User : PermissionOwner {
     [DataMember]
+    public long UserId { get; set; }
+    [DataMember]
     public String Name { get; set; }
     [DataMember]
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/UserGroup.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/UserGroup.cs	(revision 794)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/UserGroup.cs	(revision 795)
@@ -30,4 +30,6 @@
   [DataContract]
   public class UserGroup {
+    [DataMember]
+    public long UserGroupId { get; set; }
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Contracts/HeuristicLab.Hive.Contracts.csproj
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/HeuristicLab.Hive.Contracts.csproj	(revision 794)
+++ trunk/sources/HeuristicLab.Hive.Contracts/HeuristicLab.Hive.Contracts.csproj	(revision 795)
@@ -69,4 +69,5 @@
     <Compile Include="Interfaces\IClientManager.cs" />
     <Compile Include="Interfaces\IJobManager.cs" />
+    <Compile Include="Interfaces\IUserRoleManager.cs" />
     <Compile Include="MessageContainer.cs" />
     <Compile Include="ResponseJob.cs" />